datablock AudioDescription(AudioReallyFar3d)  
   {  
	volume = 1.0; 
	pitch = 1.0;
	isLooping = false;  
	isStreaming = false;
	is3D = true;
	referenceDistance = 100;
	maxDistance = 600;
	type = $SimAudioType;
   }; 
 
datablock AudioProfile(NukeRocketExplodeSound)
   {
      filename    = "./kaboom.wav";
      description = AudioReallyFar3d;
      preload = true;
   };

datablock ParticleData(NukeRocketTrailParticle)
   {
      dragCoefficient      = 3;
      gravityCoefficient   = -0.0;
      inheritedVelFactor   = 0.5;
      constantAcceleration = 0.0;
      lifetimeMS           = 7500;
      lifetimeVarianceMS   = 2000;
      textureName          = "base/data/particles/cloud";
      spinSpeed		= 10.0;
      spinRandomMin		= -150.0;
      spinRandomMax		= 150.0;
      colors[0]     = "1.0 0.8 0.0 0.4";
      colors[1]     = "1.0 0.2 0.0 0.5";
      colors[2]     = "0.50 0.50 0.50 0.4";
      colors[3]     = "0.0 0.0 0.0 0.0";

      sizes[0]      = 1;
      sizes[1]      = 3.5;
      sizes[2]      = 2;
      sizes[3]      = 0.06;

      times[0] = 0.0;
      times[1] = 0.3;
      times[2] = 0.4;
      times[3] = 1.0;

      useInvAlpha = false;
   };

   datablock ParticleEmitterData(NukeRocketTrailEmitter)
   {
      ejectionPeriodMS = 5;
      periodVarianceMS = 1;
      ejectionVelocity = 0.25;
      velocityVariance = 0.0;
      ejectionOffset   = 0.0;
      thetaMin         = 0;
      thetaMax         = 90;
      phiReferenceVel  = 0;
      phiVariance      = 360;
      overrideAdvance = false;
      particles = "NukeRocketTrailParticle";
   };

datablock ParticleData(NukeRocketExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.7;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 35000;
	lifetimeVarianceMS   = 500;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.3 0.3 0.3 1";
	colors[1]     = "0.2 0.1 0.0 0.4";
	colors[2]     = "0.2 0.1 0.1 0.0";
	sizes[0]      = 50.0;
	sizes[1]      = 100.0;
	sizes[2]      = 200.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(NukeRocketExplosionEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 35;
   velocityVariance = 1.0;
   ejectionOffset   = 10.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "NukeRocketExplosionParticle";


};
datablock ParticleData(NukeRocketExplosionGroundParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 35000;
	lifetimeVarianceMS   = 500;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -10.0;
	spinRandomMax		= 10.0;
	colors[0]     = "0.3 0.3 0.3 1";
	colors[1]     = "0.3 0.3 0.3 0.4";
	colors[2]     = "0.2 0.1 0.1 0.0";
	sizes[0]      = 40.0;
	sizes[1]      = 80.0;
	sizes[2]      = 160.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(NukeRocketExplosionGroundEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 100;
   velocityVariance = 100.0;
   ejectionOffset   = 125.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "NukeRocketExplosionGroundParticle";


};
datablock ParticleData(NukeRocketExplosionBottomParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 33000;
	lifetimeVarianceMS   = 500;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.3 0.3 0.3 0.5";
	colors[1]     = "0.2 0.1 0.0 0.4";
	colors[2]     = "0.2 0.1 0.1 0.0";
	sizes[0]      = 30.0;
	sizes[1]      = 80.0;
	sizes[2]      = 160.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(NukeRocketExplosionBottomEmitter)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 0;
   ejectionVelocity = 40;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 0;
   overrideAdvance = false;
   particles = "NukeRocketExplosionBottomParticle";


};
datablock ParticleData(NukeRocketExplosionRingParticle)
{
	dragCoefficient      = 4;
	gravityCoefficient   = -0.8;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 36000;
	lifetimeVarianceMS   = 1000;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 25.0;
	spinRandomMin		= -25.0;
	spinRandomMax		= 25.0;
	colors[0]     = "1 0.4 0.0 0.4";
	colors[1]     = "0.2 0.2 0.2 0.0";
	sizes[0]      = 15;
	sizes[1]      = 20;

	useInvAlpha = false;
};
datablock ParticleEmitterData(NukeRocketExplosionRingEmitter)
{
	lifeTimeMS = 200;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 40.0;
   velocityVariance = 1.0;
   ejectionOffset   = 70.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "NukeRocketExplosionRingParticle";
};


datablock DebrisData(NukeRocketBitsDebris)
{
   emitters = "NukeRocketExplosionBottomEmitter";

	lifetime = 4;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 0;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = false;

	gravModifier = 1;
};
datablock ExplosionData(NukeRocketExplosion)
{
   explosionShape = "./explosionSphere1.dts";
	soundProfile = NukeRocketExplodeSound;

   debris = NukeRocketBitsDebris;
   debrisNum = 1;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 0;
   debrisVelocity = 40;
   debrisVelocityVariance = 0;
   lifeTimeMS = 3500;

   particleEmitter = NukeRocketExplosionEmitter;
   particleDensity = 30;
   particleRadius = 25;

   emitter[0] = NukeRocketExplosionRingEmitter;
   emitter[1] = NukeRocketExplosionGroundEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 10.0 10.0";
   camShakeAmp = "15.0 15.0 15.0";
   camShakeDuration = 5;
   camShakeRadius = 500.0;

   // Dynamic light
   lightStartRadius = 60;
   lightEndRadius = 100;
   lightStartColor = "0.9 0.8 0.2 1";
   lightEndColor = "0.3 0.1 0.0 1";

   damageRadius = 150;
   radiusDamage = 1000;

   impulseRadius = 275;
   impulseForce = 20000;

   playerBurnTime = 5000;
};

/////////////////
//  Projectile //
/////////////////

   datablock AudioProfile(NukeRocketLoopSound)
   {
      filename    = "./rocketLoop.wav";
      description = AudioDefaultLooping3d;
      preload = true;
   };
   AddDamageType("NukeRocket",   '<bitmap:add-ons/Projectile_NukeRocket/nuked> %1',    '%2 <bitmap:add-ons/Projectile_NukeRocket/nuked> %1',1,1);
datablock ProjectileData(NukeRocketProjectile)
{
   projectileShapeName = "./nukerocket.dts";
   directDamage        = 10000;
   directDamageType = $DamageType::NukeRocket;
   radiusDamageType = $DamageType::NukeRocket;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = NukeRocketExplosion;
   particleEmitter     = NukeRocketTrailEmitter;

   brickExplosionRadius = 100;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 200;             
   brickExplosionMaxVolume = 1750;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2000;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = NukeRocketLoopSound;

   muzzleVelocity      = 85;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 100000;
   fadeDelay           = 10000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.8;

   hasLight    = true;
   lightRadius = 20.0;
   lightColor  = "1 0.5 0.0";

   uiName = "Nuclear Rocket"; //naming it this way so it's next to the rocket in the alphabetized list
};

package NukeRocketWhiteout
{
    function NukeRocketProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
    {
        initContainerRadiusSearch(%obj.getPosition(), %this.explosion.damageRadius*75, $TypeMasks::PlayerObjectType);
        while(%player = containerSearchNext())
            %player.setWhiteOut((%this.explosion.damageRadius*2)/vectorLen(vectorSub(%player.getPosition(), %obj.getPosition())));
        parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
    }
};
activatePackage(NukeRocketWhiteout);